=== modified file 'src/com/goldencode/p2j/persist/TemporaryBuffer.java'
--- old/src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-03-30 12:31:18 +0000
+++ new/src/com/goldencode/p2j/persist/TemporaryBuffer.java	2022-05-12 15:03:49 +0000
@@ -559,6 +559,7 @@
 **                           performance improvement.
 **     CA  20220330          Fixed a regression in CA/20220309 - nextPrimaryKey() will consume pending 
 **                           reclaimed PKs until they are exhausted.
+**     GES 20210430          Reworked associate() and createDynamicTable() to remove unnecessary arguments.
 */
 
 /*
@@ -1784,81 +1785,103 @@
       
       return child;
    }
-   
-   /**
-    * Associate two temp tables with one another, such that all relevant
-    * records can be copied between them at prescribed times.
-    *
-    * @param   src
-    *          <code>TableParameter</code> containing reference to the source
-    *          temporary buffer or result set.
-    * @param   dstDMO
-    *          DMO instance returned by a previous call to {@link #define} on
-    *          the destination temporary buffer.
-    * @param   input
-    *          if <code>true</code>, records are copied from source table to
-    *          destination table immediately upon invocation of this method,
-    *          otherwise they are not.
-    * @param   output
-    *          if <code>true</code>, records are copied from destination
-    *          table back to source table when the current transaction or
-    *          subtransaction is committed;  otherwise they are not.
-    *
-    * @throws  ErrorConditionException
-    *          if a recoverable error occurs flushing the source buffer in
-    *          preparation for an input copy or while copying records.
-    * @throws  RuntimeException
-    *          if an unrecoverable error occurs invoking methods on the
-    *          underlying DMOs to get or set data values.
-    */
-   public static void associate(final TableParameter src,
-                                final Temporary dstDMO,
-                                boolean input,
-                                boolean output)
-   {
-      associate(src, dstDMO, input, output, false, ParameterOption.NONE);
-   }
-   
-   /**
-    * Associate two temp tables with one another, such that all relevant
-    * records can be copied between them at prescribed times.
-    *
-    * @param   src
-    *          <code>TableParameter</code> containing reference to the source
-    *          temporary buffer or result set.
-    * @param   dstDMO
-    *          DMO instance returned by a previous call to {@link #define} on
-    *          the destination temporary buffer.
-    * @param   input
-    *          if <code>true</code>, records are copied from source table to
-    *          destination table immediately upon invocation of this method,
-    *          otherwise they are not.
-    * @param   output
-    *          if <code>true</code>, records are copied from destination
-    *          table back to source table when the current transaction or
-    *          subtransaction is committed;  otherwise they are not.
-    * @param   appendInput
-    *          <code>true</code> to add new records without affecting
-    *          existing records;  <code>false</code> to remove all existing
-    *          records before the copy takes place.  This option affects the
-    *          <code>input</code> copy only, not the <code>output</code> copy.
-    *
-    * @throws  ErrorConditionException
-    *          if a recoverable error occurs flushing the source buffer in
-    *          preparation for an input copy or while copying records.
-    * @throws  RuntimeException
-    *          if an unrecoverable error occurs invoking methods on the
-    *          underlying DMOs to get or set data values.
-    */
-   public static void associate(final TableParameter src,
-                                final Temporary dstDMO,
-                                boolean input,
-                                boolean output,
-                                boolean appendInput)
-   {
-      associate(src, dstDMO, input, output, appendInput, ParameterOption.NONE);
-   }
-   
+
+   /**
+    * Associate two temp tables with one another, such that all relevant
+    * records can be copied between them at prescribed times.
+    *
+    * @param    src
+    *           <code>TableParameter</code> containing reference to the source
+    *           temporary buffer or result set.
+    * @param    dstDMO
+    *           DMO instance returned by a previous call to {@link #define} on
+    *           the destination temporary buffer.
+    *
+    * @throws   ErrorConditionException
+    *           if a recoverable error occurs flushing the source buffer in
+    *           preparation for an input copy or while copying records.
+    * @throws   RuntimeException
+    *           if an unrecoverable error occurs invoking methods on the
+    *           underlying DMOs to get or set data values.
+    */
+   public static void associate(TableParameter src, Temporary dstDMO)
+   {
+      associate(src, dstDMO, ParameterOption.NONE);
+   }
+   
+   /**
+    * Associate two temp tables with one another, such that all relevant
+    * records can be copied between them at prescribed times.
+    *
+    * @param    src
+    *           <code>TableParameter</code> containing reference to the source
+    *           temporary buffer or result set.
+    * @param    dstDMO
+    *           DMO instance returned by a previous call to {@link #define} on
+    *           the destination temporary buffer.
+    * @param    input
+    *           if <code>true</code>, records are copied from source table to
+    *           destination table immediately upon invocation of this method,
+    *           otherwise they are not.
+    * @param    output
+    *           if <code>true</code>, records are copied from destination
+    *           table back to source table when the current transaction or
+    *           subtransaction is committed;  otherwise they are not.
+    *
+    * @throws   ErrorConditionException
+    *           if a recoverable error occurs flushing the source buffer in
+    *           preparation for an input copy or while copying records.
+    * @throws   RuntimeException
+    *           if an unrecoverable error occurs invoking methods on the
+    *           underlying DMOs to get or set data values.
+    */
+   public static void associate(TableParameter src,
+                                Temporary      dstDMO,
+                                boolean        input,
+                                boolean        output)
+   {
+      associate(src, dstDMO, input, output, ParameterOption.NONE);
+   }
+   
+   /**
+    * Associate two temp tables with one another, such that all relevant records can be copied
+    * between them at prescribed times.
+    *
+    * @param    src
+    *           {@code TableParameter} containing reference to the source temporary buffer or
+    *           result set.
+    * @param    dstDMO
+    *           DMO instance returned by a previous call to {@link #define} on the destination
+    *           temporary buffer.
+    * @param    input
+    *           If {@code true}, records are copied from source table to destination table
+    *           immediately upon invocation of this method, otherwise they are not.
+    * @param    output
+    *           If {@code true}, records are copied from destination table back to source table
+    *           when the current transaction or subtransaction is committed;  otherwise they are
+    *           not.
+    * @param    option
+    *           Parameter passing mode APPEND, BY-VALUE, BIND or BY-REFERENCE option.
+    *
+    * @throws   ErrorConditionException
+    *           if a recoverable error occurs flushing the source buffer in preparation for an
+    *           input copy or while copying records.
+    * @throws   RuntimeException
+    *           if an unrecoverable error occurs invoking methods on the underlying DMOs to get or
+    *           set data values.
+    */
+   public static void associate(TableParameter  src,
+                                Temporary       dstDMO,
+                                boolean         input,
+                                boolean         output,
+                                ParameterOption option)
+   {
+      src.setInputMode(input);
+      src.setOutputMode(output);
+      
+      associate(src, dstDMO, option);
+   }
+
    /**
     * Associate two temp tables with one another, such that all relevant records can be copied
     * between them at prescribed times.
@@ -1869,19 +1892,8 @@
     * @param   dstDMO
     *          DMO instance returned by a previous call to {@link #define} on the destination
     *          temporary buffer.
-    * @param   input
-    *          If {@code true}, records are copied from source table to destination table
-    *          immediately upon invocation of this method, otherwise they are not.
-    * @param   output
-    *          If {@code true}, records are copied from destination table back to source table
-    *          when the current transaction or subtransaction is committed;  otherwise they are
-    *          not.
-    * @param   appendInput
-    *          Use {@code true} to add new records without affecting existing records;
-    *          {@code false} to remove all existing records before the copy takes place. This
-    *          option affects the {@code input} copy only, not the {@code output} copy.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
     *
     * @throws  ErrorConditionException
     *          if a recoverable error occurs flushing the source buffer in preparation for an
@@ -1890,12 +1902,7 @@
     *          if an unrecoverable error occurs invoking methods on the underlying DMOs to get or
     *          set data values.
     */
-   public static void associate(final TableParameter src,
-                                Temporary dstDMO,
-                                boolean input,
-                                boolean output,
-                                boolean appendInput,
-                                ParameterOption mode)
+   public static void associate(final TableParameter src, Temporary dstDMO, ParameterOption option)
    {
       if (src.getTable() == (Temporary) ((BufferImpl) dstDMO).ref())
       {
@@ -1903,6 +1910,10 @@
          return;
       }
       
+      boolean input  = src.isInputMode();
+      boolean output = src.isOutputMode();
+      boolean append = (option == ParameterOption.APPEND);
+      
       if (!(input || output))
       {
          throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");
@@ -1937,7 +1948,8 @@
          return;
       }
       
-      boolean bind = src.isBind() || mode == ParameterOption.BIND;
+      boolean bind = src.isBind() || option == ParameterOption.BIND;
+      
       if (src.isByReference() || bind || (!src.isRemoteParameter() && buffer.referenceOnly))
       {
          if (src.getTable() == null)
@@ -1985,14 +1997,10 @@
                else
                {
                   TableParameter beforeParam = new TableParameter((Temporary) hSrcBefore.getResource(),
-                                                                  src.isAppend(),
-                                                                  src.getParameterMode());
-                  associate(beforeParam, 
-                            (Temporary) hDstBefore.getResource(), 
-                            input, 
-                            output, 
-                            appendInput, 
-                            mode);
+                                                                  src.getParameterOption(),
+                                                                  input,
+                                                                  output);
+                  associate(beforeParam, (Temporary) hDstBefore.getResource(), option);
                }
             }
             
@@ -2026,6 +2034,7 @@
             
             // find all other explicit buffers in this table and create a new buffer for them
             Set<Temporary> copy = new HashSet<>(dstBuf.explicitBuffers);
+            
             for (Temporary buf : copy)
             {
                TemporaryBuffer exBuf = (TemporaryBuffer) ((BufferReference) buf).definition();
@@ -2082,6 +2091,7 @@
          if (!src.isRemoteParameter())
          {
             Temporary srcDMO = src.getTable();
+
             if (srcDMO != null)
             {
                TemporaryBuffer srcBuf = (TemporaryBuffer) ((BufferReference) srcDMO).buffer();
@@ -2126,7 +2136,7 @@
                                  ? srcBuf.rowID() 
                                  : null;
                
-               boolean res = copyAllRows(srcRec,srcDMO, dstDMO, appendInput, CopyTableMode.INPUT_PARAM_MODE);
+               boolean res = copyAllRows(srcRec, srcDMO, dstDMO, append, CopyTableMode.INPUT_PARAM_MODE);
                if (!res)
                {
                   BlockManager.returnError();
@@ -2136,13 +2146,13 @@
          else if (src.getResultSet().getXmlTable() != null)
          {
             String xmlTable = src.getResultSet().getXmlTable();
-            readFromXml(xmlTable, appendInput, ((Buffer) dstDMO).tableHandle());
+            readFromXml(xmlTable, append, ((Buffer) dstDMO).tableHandle());
          }
          else
          {
             insertAllRows(src.getResultSet(),
                           dstDMO,
-                          appendInput,
+                          append,
                           CopyTableMode.INPUT_PARAM_MODE,
                           src.getParameterIndex());
          }
@@ -2164,61 +2174,93 @@
          ProcedureManager.executeOnReturn(copier::finished, copier.weight());
       }
    }
-   
-   /**
-    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
-    * conversion of DEFINE PARAMETER TABLE-HANDLE.
-    *
-    * @param   src
-    *          <code>TableParameter</code> containing reference to the source table.
-    * @param   target
-    *          Handle for storing the target table.
-    * @param   input
-    *          if <code>true</code>, records are copied from source table to
-    *          destination table immediately upon invocation of this method,
-    *          otherwise they are not.
-    * @param   output
-    *          if <code>true</code>, records are copied from destination
-    *          table back to source table when the current transaction or
-    *          subtransaction is committed;  otherwise they are not.
-    */
-   public static void createDynamicTable(TableParameter src,
-                                         handle target,
-                                         boolean input,
-                                         boolean output)
-   {
-      createDynamicTable(src, target, input, output, false, ParameterOption.NONE);
-   }
-   
-   /**
-    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
-    * conversion of DEFINE PARAMETER TABLE-HANDLE.
-    *
-    * @param   src
-    *          {@code TableParameter} containing reference to the source table.
-    * @param   target
-    *          Handle for storing the target table.
-    * @param   input
-    *          If {@code true}, records are copied from source table to destination table
-    *          immediately upon invocation of this method, otherwise they are not.
-    * @param   output
-    *          If {@code true}, records are copied from destination table back to source table
-    *          when the current transaction or subtransaction is committed;  otherwise they are
-    *          not.
-    * @param   append
-    *          {@code true} to add new records without affecting existing records; {@code false}
-    *          to remove all existing records before the copy takes place. This option affects the
-    *          {@code input} copy only, not the {@code output} copy.
-    * @param   mode
-    *          Parameter passing mode BY-VALUE, BIND or BY-REFERENCE option.
-    */
-   public static void createDynamicTable(TableParameter src,
-                                         handle target,
-                                         boolean input,
-                                         boolean output,
-                                         boolean append,
-                                         ParameterOption mode)
-   {
+
+   /**
+    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
+    * conversion of DEFINE PARAMETER TABLE-HANDLE.
+    *
+    * @param    src
+    *           <code>TableParameter</code> containing reference to the source table.
+    * @param    target
+    *           Handle for storing the target table.
+    */
+   public static void createDynamicTable(TableParameter src, handle target)
+   {
+      createDynamicTable(src, target, ParameterOption.NONE);
+   }
+   
+   /**
+    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
+    * conversion of DEFINE PARAMETER TABLE-HANDLE.
+    *
+    * @param    src
+    *           <code>TableParameter</code> containing reference to the source table.
+    * @param    target
+    *           Handle for storing the target table.
+    * @param    input
+    *           if <code>true</code>, records are copied from source table to
+    *           destination table immediately upon invocation of this method,
+    *           otherwise they are not.
+    * @param    output
+    *           if <code>true</code>, records are copied from destination
+    *           table back to source table when the current transaction or
+    *           subtransaction is committed;  otherwise they are not.
+    */
+   public static void createDynamicTable(TableParameter src,
+                                         handle         target,
+                                         boolean        input,
+                                         boolean        output)
+   {
+      createDynamicTable(src, target, input, output, ParameterOption.NONE);
+   }
+   
+   /**
+    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
+    * conversion of DEFINE PARAMETER TABLE-HANDLE.
+    *
+    * @param    src
+    *           {@code TableParameter} containing reference to the source table.
+    * @param    target
+    *           Handle for storing the target table.
+    * @param    input
+    *           If {@code true}, records are copied from source table to destination table
+    *           immediately upon invocation of this method, otherwise they are not.
+    * @param    output
+    *           If {@code true}, records are copied from destination table back to source table
+    *           when the current transaction or subtransaction is committed;  otherwise they are
+    *           not.
+    * @param    option
+    *           Parameter passing mode APPEND, BY-VALUE, BIND or BY-REFERENCE option.
+    */
+   public static void createDynamicTable(TableParameter  src,
+                                         handle          target,
+                                         boolean         input,
+                                         boolean         output,
+                                         ParameterOption option)
+   {
+      src.setInputMode(input);
+      src.setOutputMode(output);
+      
+      createDynamicTable(src, target, option);
+   }
+
+   /**
+    * Creates a dynamic temporary table for the given temp table handle. Intended to handle
+    * conversion of DEFINE PARAMETER TABLE-HANDLE.
+    *
+    * @param    src
+    *           {@code TableParameter} containing reference to the source table.
+    * @param    target
+    *           Handle for storing the target table.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public static void createDynamicTable(TableParameter src, handle target, ParameterOption option)
+   {
+      boolean input  = src.isInputMode();
+      boolean output = src.isOutputMode();
+      boolean append = (option == ParameterOption.APPEND);
+      
       if (!(input || output))
       {
          throw new IllegalStateException("Parameter mode (INPUT/OUTPUT) was not specified!");

=== modified file 'src/com/goldencode/p2j/schema/SchemaDictionary.java'
--- old/src/com/goldencode/p2j/schema/SchemaDictionary.java	2022-05-01 15:40:07 +0000
+++ new/src/com/goldencode/p2j/schema/SchemaDictionary.java	2022-05-12 15:30:45 +0000
@@ -515,6 +515,9 @@
 **                           profiles to be ran at once, with the conversion switching the state between 
 **                           profiles, when a resource (like a file or namespace) is being processed.  Only
 **                           front phase is supported at this time.
+**     GES 20210208          Added table-level signature calculation (saved as an annotation). Added
+**                           findTableInfo() to provide a set of related data about a matched record. This
+**                           saves multiple calls each having to resolve the same name node lookup.
 */
 
 /*
@@ -1789,6 +1792,9 @@
          copyTableProperties(ast, table);
       }
       
+      // calculate and save the table signature
+      calculateSignature(table);
+
       if (modelTable == null)
       {
          // Temp-table has been defined without using a "like" clause.
@@ -1939,6 +1945,65 @@
    }
    
    /**
+    * Get the Progress parser token type of a table, temp-table, work-table,
+    * or buffer. If <code>name</code> represents a buffer, the type of the
+    * backing record is returned. That is, a type of <code>BUFFER</code> is
+    * never returned, only the type of the record which backs the buffer.
+    * <p>
+    * If both forceTemp and forcePersistent are <code>false</code>, then the lookup is performed
+    * with no preference for temp-table or persistent table.
+    *
+    * @param   name
+    *          Case insensitive record name; may be qualified or not. If
+    *          qualified, only the table portion of the name may be
+    *          abbreviated.
+    * @param   forceTemp
+    *          If <code>true</code>, force a temp-table lookup.
+    * @param   forcePersistent
+    *          If <code>true</code>, force a persistent table lookup.
+    *
+    * @return  One of the Progress parser token types <code>TABLE</code>,
+    *          <code>TEMP_TABLE</code>, or <code>WORK_TABLE</code>, or
+    *          <code>UNKNOWN</code> if <code>name</code> cannot be found.
+    *
+    * @throws  AmbiguousSchemaNameException
+    *          if <code>name</code> is an ambiguous identifier for the
+    *          target record.
+    */
+   public TableInfo findTableInfo(String name, boolean forceTemp, boolean forcePersistent)
+   throws AmbiguousSchemaNameException
+   {
+      // TODO: The recordType lookup used scopes.size() - 1 instead of nearestEnclosingInternal(), is this
+      //       an issue?  It seems like it should have been consistent with the other lookups, so this is
+      //       being made consistent here.
+      int l1 = computeLevel(forceTemp, forcePersistent, true, nearestEnclosingInternal());
+      int l2 = computeLevel(forceTemp, forcePersistent, false, SCHEMA_GLOBAL_SCOPE);
+
+      // Look up record name node.
+      NameNode node = findEntry(name, EntityName.TABLE, l1, l2, false);
+      
+      TableInfo info = null;
+      
+      if (node != null)
+      {
+         NameNode dbNode  = node.getParent();
+         
+         // don't just use getAst() here, we need the AST for the backing table if this is a buffer
+         // (this will work for both the simple case and the buffer case)
+         Aast   ast   = getTable(node); 
+         String sig   = ast != null ? (String) ast.getAnnotation("db_signature") : null;
+         String sname = getQualifiedName(node);
+         String bname = getRecordName(node, EntityName.TABLE, name);
+         String dname = (dbNode != null) ? dbNode.getName() : "";
+         int    ttype = getTable(node).getType();
+         
+         info = new TableInfo(sig, sname, bname, dname, ttype);
+      }
+      
+      return info;
+   }
+   
+   /**
     * Get an object which exposes schema-related information about a field which is referenced in
     * source code.
     * 
@@ -5057,6 +5122,74 @@
    }
    
    /**
+    * Calculate and save the signature for the table.  Each field is represented by "datatype" or
+    * "datatype[extent]" format.  The table level signature is all of the field signatures separated
+    * by "|" delimiter with the number and order of the fields matching the order in the AST.
+    *  
+    * @param    table
+    *           The table AST substree.
+    */
+   private void calculateSignature(Aast table)
+   {
+      String signature = "";
+      
+      Aast next = (Aast) table.getFirstChild();
+
+      // iterate through all fields
+      while (next != null)
+      {
+         int type = next.getType();
+         
+         // if this is a field, calculate the field's portion of the signature
+         if (type >= BEGIN_FIELDTYPES && type <= END_FIELDTYPES ||
+             type >= BEGIN_METATYPES  && type <= END_METATYPES)
+         {
+            Aast ext = next.getImmediateChild(KW_EXTENT, null);
+            
+            String extent = null;
+            
+            // read the extent value if any
+            if (ext != null)
+            {
+               if (ext.getNumImmediateChildren() == 0)
+               {
+                  String err = String.format("Indeterminate EXTENT in a temp-table definition for %s",
+                                             next.dumpTree());
+                  
+                  // indeterminate extent does not make sense for a temp-table, should not happen
+                  throw new RuntimeException(err);
+               }
+               else
+               {
+                  // the only child is a NUM_LITERAL
+                  Aast num = (Aast) ext.getFirstChild();
+                  extent = num.getText();
+               }
+            }
+            
+            // create the field portion of the signature
+            String fsig = SchemaParser.fieldSignature(type, extent);
+            
+            // add it in to the table signature
+            signature += (signature.length() == 0) ? fsig : "|" + fsig;
+         }
+
+         next = (Aast) next.getNextSibling();
+      }
+
+      // save the result
+      if (signature.isEmpty())
+      {
+         // there should always be at least 1 field
+         throw new RuntimeException(String.format("Invalid temp-table, no fields!\n%s", table.dumpTree()));
+      }
+      else
+      {
+         table.putAnnotation("db_signature", signature);
+      }
+   }
+   
+   /**
     * Copy TABLE properties from a source AST to a destination AST. The set
     * of properties (essentially child AST nodes) copied will be limited to
     * those that are valid in a table (filtered by token type). It is assumed

